%Produces a bifurcation curve from a2 to a1 for the connecting orbits w1,
%w2 at a2.

function [xr,xxx,g,J2,x_old,x_old2,x_1,x_2]=Bif_Diag(w1,w2)
%Henon Parameters:
a_int=intval(1245)/intval(1000);%intval(13050)/intval(10000);
%a_int = intval(13)/intval(10);
b_int = intval('0.3');
a1=1.1538;%1.224;%1.23;
a2=1.175;%1.23;%1.24;%1.16;%1.34
[~, L]=size(w1);
b=0.3;
%Parameterization Controls:
M2 = 15;
N2 = 25; 

scale_eigs = intval(1);

%Parameter Domains:
tauBar1 = intval('0.1325');
tau = intval('0.1325');   %0.23 works
nu = intval('0.95');
%First Fixed Point:

[P1s_MNx, P1s_MNy, delta1s] = manifoldBranch_1Stable(...
    a_int,  b_int, M2, N2, tauBar1,tau, nu, scale_eigs);

[P1s_x, P1s_y] = convertToPoly_2Dbranch_2Dspace(P1s_MNx, P1s_MNy, M2, N2);

[P1u_MNx, P1u_MNy, delta1u] = manifoldBranch_1Unstable(...
    a_int,  b_int, M2, N2, tauBar1,tau, nu, scale_eigs);

[P1u_x, P1u_y] = convertToPoly_2Dbranch_2Dspace(P1u_MNx, P1u_MNy, M2, N2);




P1ux_theta = pderiv(P1u_x,'x', 1);  %First Derivative of P1 wrt theta
P1uy_theta=pderiv(P1u_y,'x', 1);
P1sx_theta = pderiv(P1s_x,'x', 1);
P1sy_theta=pderiv(P1s_y,'x', 1);

P1ux_theta2 = pderiv(P1u_x,'x', 2);  %Second Derivative of P1 wrt theta
P1uy_theta2=pderiv(P1u_y,'x', 2);
P1sx_theta2 = pderiv(P1s_x,'x', 2);
P1sy_theta2=pderiv(P1s_y,'x', 2);


P1ux_tau = pderiv(P1u_x,'t', 1);  %First Derivative of P1 wrt tau
P1uy_tau=pderiv(P1u_y,'t', 1);
P1sx_tau = pderiv(P1s_x,'t', 1);
P1sy_tau=pderiv(P1s_y,'t', 1);

P1ux_tau2 = pderiv(P1u_x,'t', 2);  %Second Derivative of P1 wrt tau
P1uy_tau2=pderiv(P1u_y,'t', 2);
P1sx_tau2 = pderiv(P1s_x,'t', 2);
P1sy_tau2=pderiv(P1s_y,'t', 2);

P1ux_tautheta=pderiv(P1ux_theta,'t',1);  %Mixed Derivative of P1
P1uy_tautheta=pderiv(P1uy_theta,'t',1);
P1sx_tautheta=pderiv(P1sx_theta,'t',1);
P1sy_tautheta=pderiv(P1sy_theta,'t',1);

P1ux_theta3 = pderiv(P1u_x,'x', 3);  %Third Derivative of P1 wrt theta
P1uy_theta3=pderiv(P1u_y,'x', 3);
P1sx_theta3 = pderiv(P1s_x,'x', 3);
P1sy_theta3=pderiv(P1s_y,'x', 3);

P1ux_tautheta2=pderiv(P1ux_theta2,'t',1);  %Mixed Derivative of P1
P1uy_tautheta2=pderiv(P1uy_theta2,'t',1);
P1sx_tautheta2=pderiv(P1sx_theta2,'t',1);
P1sy_tautheta2=pderiv(P1sy_theta2,'t',1);

P1ux_tau2theta=pderiv(P1ux_tau2,'x',1);  %Mixed Derivative of P1
P1uy_tau2theta=pderiv(P1uy_tau2,'x',1);
P1sx_tau2theta=pderiv(P1sx_tau2,'x',1);
P1sy_tau2theta=pderiv(P1sy_tau2,'x',1);

P1ux_tau3 = pderiv(P1u_x,'t', 3);  %Third Derivative of P1 wrt theta
P1uy_tau3=pderiv(P1u_y,'t', 3);
P1sx_tau3 = pderiv(P1s_x,'t', 3);
P1sy_tau3=pderiv(P1s_y,'t', 3);
%Second Fixed Point:
% 
% [P2s_MNx, P2s_MNy, delta2s] = manifoldBranch_2Stable(...
%     a2,  b2, M2, N2, tauBar1,tau, nu, scale_eigs);
% 
% 
% [P2u_MNx, P2u_MNy, delta2u] = manifoldBranch_2Untable(...
%     a2,  b2, M2, N2, tauBar1,tau, nu, scale_eigs);


%Homoclinic function
function [g_intval]=gn_intval(x_int,aa_int,d)
        g_intval=zeros(L,1);
%         P_x_intval=mid(polyval(P1u_x,d,intval(x_int(L-1))));
%         P_y_intval=mid(polyval(P1u_y,d,intval(x_int(L-1))));
%         Q_x_intval=mid(polyval(P1s_x,d,intval(x_int(L))));
%         Q_y_intval=mid(polyval(P1s_y,d,intval(x_int(L))));        
        g_intval(1,1)=mid(polyval(P1u_x,d,intval(x_int(L-1))))-x_int(1);
        g_intval(2,1)=mid(polyval(P1u_y,d,intval(x_int(L-1))))-x_int(2);

        for i=3:L-2
            if mod(i,2)==0
                g_intval(i,1)=b*x_int(i-3)-x_int(i);
            elseif mod(i,2)==1
                g_intval(i,1)=1-aa_int*x_int(i-2)^2+x_int(i-1)-x_int(i);
             end
        end
        g_intval(L-1,1)=1-aa_int*x_int(L-3)^2+x_int(L-2)-mid(polyval(P1s_x,d,intval(x_int(L))));
        g_intval(L,1)=b*x_int(L-3)-mid(polyval(P1s_y,d,intval(x_int(L))));
end


    function [J2_intval]=jacob2_intval(x_int,aa_int,d)
        J2_intval=zeros(L,L);
        dP_x_intval=mid(polyval(P1ux_theta,d,intval(x_int(L-1))));
        dP_y_intval=mid(polyval(P1uy_theta,d,intval(x_int(L-1))));
        dQ_x_intval=mid(polyval(P1sx_theta,d,intval(x_int(L))));
        dQ_y_intval=mid(polyval(P1sy_theta,d,intval(x_int(L))));
        for i=1:L
            for j=1:L
                if i==1
                    if j==1
                    J2_intval(i,j)=-1;
                    elseif j==L-1
                            J2_intval(i,j)=dP_x_intval;
                    end
                elseif i==2
                    if j==2
                        J2_intval(i,j)=-1;
                    elseif j==L-1
                            J2_intval(i,j)=dP_y_intval;
                    end
                elseif i==L-1
                    if j==L-3
                        J2_intval(i,j)=-2*aa_int*x_int(j);
                    elseif j==L-2
                        J2_intval(i,j)=1;
                    elseif j==L
                        J2_intval(i,j)=-dQ_x_intval;
                    end
                elseif i==L
                        if j==L-3
                        J2_intval(i,j)=b;
                    elseif j==L
                        J2_intval(i,j)=-dQ_y_intval;
                        end
                elseif i>2 && i<=L-2 && mod(i,2)==1
                    if j==i-2
                        J2_intval(i,j)=-2*aa_int*x_int(j);
                    elseif j==i-1
                        J2_intval(i,j)=1;
                    elseif j==i
                        J2_intval(i,j)=-1;
                    end
                 elseif i>2 && i<=L-2 && mod(i,2)==0
                     if j==i
                         J2_intval(i,j)=-1;
                     elseif j==i-3
                         J2_intval(i,j)=b;
                     end
                end
            end
                     
 
        end
    end

    function [D_a]=D_aJacob(x_int,a_int,d)
        x_mid=mid(x_int);
        D_a=zeros(L,1);
        dP_x_intval=polyval(P1ux_tau,d,intval(x_int(L-1)));
        dP_y_intval=polyval(P1uy_tau,d,intval(x_int(L-1)));
        dQ_x_intval=polyval(P1sx_tau,d,intval(x_int(L)));
        dQ_y_intval=polyval(P1sy_tau,d,intval(x_int(L)));
        D_a(1)=mid(dP_x_intval);
        D_a(2)=mid(dP_y_intval);
        D_a(L-1)=-x_mid(L-3)^2-mid(dQ_x_intval);
        D_a(L)=-mid(dQ_y_intval);
        D_a(2)=mid(dP_y_intval);
        for i=3:L-2
            if mod(i,2)==1
                D_a(i)=-x_mid(i-2);
            end
        end
    end
           
           
        
    
counter3=1;
function x=Newton_Henon(x0,a)%x = Newton_Henon(x0,aa,v)
N = 2000; % define max. number of iterations 
epsilon = 1e-13; % define tolerance 
maxval = 20000.0; % define value for divergence 
xx = mid(x0); % load initial guess 
   g=zeros(19,110);         
       
      xr=zeros(18,100);
while (N>0) 
 %JJ = feval(jacobnxn,xx);
 %JJ=mid(jacob2_intval(intval(xx),aa,aa-a_int));
 JJ=jacob2_intval(xx,a,a-a_int);
if abs(det(JJ))<epsilon 
 error('newtonm - Jacobian is singular - try new x0'); 
 abort; 
end
% xn = xx - inv(JJ)*feval(fn,xx);
 %xn = xx - (inv(JJ)*mid(gn_intval(intval(xx),aa,aa-a_int)))';
 xn = xx - (JJ\gn_intval(xx,a,a-a_int))';
 xr(:,N)=gn_intval(xn,a,a-a_int);
%if abs(feval(fn,xn))<epsilon 
 %if norm(mid(gn_intval(intval(xn),aa,aa-a_int)))<epsilon 
 if norm(gn_intval(xn,a,a-a_int))<epsilon
     g(:,counter3)=[mid(gn_intval(xn,a,a-a_int));a];
       counter3=counter3+1;
 x=xn; 
 iter = 2000-N; 
 disp(['iterations = ',num2str(iter)]); 
 return; 
 end
%if abs(feval(fn,xx))>maxval 
 if norm(gn_intval(xn,a,a-a_int))>maxval 
 iter = 2000-N; 
 disp(['iterations = ',num2str(iter)]); 
 error('Solution diverges'); 
 abort;
 end
 N = N - 1; 
 xx = xn; 
end 

error('No convergence after 2000 iterations.'); 
abort; 
end 
xxx=gn_intval(Newton_Henon(w1,a1),a1,a1-a_int);
x_1=zeros(18,110);
x_old=zeros(18,110);
%g=zeros(18,110);
counter=1;
x_old(:,1)=w1;
for a=a2:-0.000212:a1       
%     x_new=x_1(:,counter)';
    x_1(:,counter)=Newton_Henon(x_old(:,counter)',a);
x_old(:,counter+1)=x_1(:,counter)+(.0001*inv(mid(jacob2_intval(x_1(:,counter),a,a-a1)))*D_aJacob(x_1(:,counter),a,a-a1));
counter=counter+1;

end
x_2=zeros(18,110);
counter2=1;
x_old2=w2;
for a=a2:-0.000212:a1
    x_new2=Newton_Henon(x_old2,a);
    x_2(:,counter2)=x_new2;
    counter2=counter2+1;
x_old2=x_new2+(.0001*inv(mid(jacob2_intval(x_new2,a,a-a1)))*D_aJacob(x_new2,a,a-a1))';
%x_2(:,counter2)=x_new2;
end
figure
plot([a2:-0.000212:a1],x_1(1,1:101),'r.',[a2:-0.000212:a1],x_2(1,1:101),'b.')
title('Bifurcation Diagram')
xlabel('a')
ylabel('|x_1|') 
  J2=mid(jacob2_intval(Newton_Henon(w1,a1),a1,a1-a_int));
  
% figure
% plot([a2:-0.000138:1.165],X(1:101),'r.',[1.17:-0.00005:1.165],Y(1:101),'b.',[1.165:-0.00005:1.16],X(101:201),'r.',[1.165:-0.00005:1.16],Y(101:201),'b.',[1.16:-0.00003:1.157],X(203:303),'r.',[1.16:-0.00003:1.157],Y(203:303),'b.')
% title('Bifurcation Diagram')
% xlabel('a')
% ylabel('|x_1|')

% Test = open('bifdiag.fig');
%     figure(Test)
%      pause(2)  %pause for you to see that it is bringing ur fig up
%     hold on
%     plot([a2:-0.000212:a1],x_2(1,1:101),'r.',[a2:-0.000212:a1],x_1(1,1:101),'r.')
    
    
end