% Saddle node validation

function[R1_w,R2_w,x_w,GG,x_eig,FF,x1_int,DF_eig_intval,A2,F_eig_intval,zero_eig_index,E,n,check,R_1,R_2,r1,r2,Ybd_e,M,V,D,R1,R2,r_1,r_2,Ybd,ZQ,ZL,Z]=Saddle_Node_Validation
format long
L=18;
%a=1.4: .5 .3 -.5 1.5 -1 4
%a=1.4;
%a1=1.22447;

%b=0.3;
%Henon Parameters:
%a_int=intval(13855)/intval(10000);
%a_int = intval(13)/intval(10);





%Homoclinic function
function [g_intval]=gn_intval(x_int,aa_int,d)
        g_intval=intval(zeros(L,1));
        P_x_intval=polyval(P1u_x,d,x_int(L-1));
        P_y_intval=polyval(P1u_y,d,x_int(L-1));
        Q_x_intval=polyval(P1s_x,d,x_int(L));
        Q_y_intval=polyval(P1s_y,d,x_int(L));        
        g_intval(1)=P_x_intval-x_int(1);
        g_intval(2)=P_y_intval-x_int(2);

        for i=3:L-2
            if mod(i,2)==0
                g_intval(i)=b_int*x_int(i-3)-x_int(i);
            elseif mod(i,2)==1
                g_intval(i)=intval(1)-aa_int*x_int(i-2)^2+x_int(i-1)-x_int(i);
             end
        end
        g_intval(L-1)=intval(1)-aa_int*x_int(L-3)^2+x_int(L-2)-Q_x_intval;
        g_intval(L)=b_int*x_int(L-3)-Q_y_intval;
end


    function [J2_intval]=jacob2_intval(x_int,aa_int,d)
        J2_intval=intval(zeros(L,L));
        dP_x_intval=polyval(P1ux_theta,d,x_int(L-1));
        dP_y_intval=polyval(P1uy_theta,d,x_int(L-1));
        dQ_x_intval=polyval(P1sx_theta,d,x_int(L));
        dQ_y_intval=polyval(P1sy_theta,d,x_int(L));
        for i=1:L
            for j=1:L
                if i==1
                    if j==1
                    J2_intval(i,j)=-intval(1);
                    elseif j==L-1;
                            J2_intval(i,j)=dP_x_intval;
                    end
                elseif i==2
                    if j==2
                        J2_intval(i,j)=-intval(1);
                    elseif j==L-1
                            J2_intval(i,j)=dP_y_intval;
                    end
                elseif i==L-1
                    if j==L-3
                        J2_intval(i,j)=-intval(2)*aa_int*x_int(j);
                    elseif j==L-2
                        J2_intval(i,j)=intval(1);
                    elseif j==L
                        J2_intval(i,j)=-dQ_x_intval;
                    end
                elseif i==L
                        if j==L-3
                        J2_intval(i,j)=b_int;
                    elseif j==L
                        J2_intval(i,j)=-dQ_y_intval;
                        end
                elseif i>2 && i<=L-2 && mod(i,2)==1
                    if j==i-2
                        J2_intval(i,j)=-intval(2)*aa_int*x_int(j);
                    elseif j==i-1
                        J2_intval(i,j)=intval(1);
                    elseif j==i
                        J2_intval(i,j)=-intval(1);
                    end
                 elseif i>2 && i<=L-2 && mod(i,2)==0
                     if j==i
                         J2_intval(i,j)=-intval(1);
                     elseif j==i-3
                         J2_intval(i,j)=b_int;
                     end
                end
            end
                     
 
        end
    end

    function [F]=F_saddle_intval(x)
        x_int=intval(x(1:L));
        a3_int=intval(x(L+1));
        vv=intval(x(L+2:2*L+1))';
        F=intval(zeros(1,2*L+1));
        F(1:L)=gn_intval(x_int,a3_int,a3_int-a_int);
        F(L+1)=norm(vv)^2-intval(1);
        F(L+2:2*L+1)=jacob2_intval(x_int,a3_int,a3_int-a_int)*vv;
        F=F';
    end

    function [DF]=DF_saddle_intval(x)
        x_int=intval(x(1:L));
        aa_int=intval(x(L+1));
        JJ=jacob2_intval(x_int,aa_int,aa_int-a_int);
        V=intval(x(L+2:2*L+1));
        DF=intval(zeros(2*L+1,2*L+1));
        DF(1:L,1:L)=JJ;
        DF(L+2:2*L+1,L+2:2*L+1)=JJ;
        DF(L+1,L+2:2*L+1)=2*V;
        DF(1,L+1)=polyval(P1ux_tau,aa_int-a_int,x_int(L-1));
        DF(2,L+1)=polyval(P1uy_tau,aa_int-a_int,x_int(L-1));
        for i=3:L-2
            if mod(i,2)==1
                DF(i,L+1)=-x_int(i-2)^2;
            end
        end
        DF(L-1,L+1)=-x_int(L-3)^2-polyval(P1sx_tau,aa_int-a_int,x_int(L));
        DF(L,L+1)=-polyval(P1sy_tau,aa_int-a_int,x_int(L));
        DF(L+2,L-1)=polyval(P1ux_theta2,aa_int-a_int,x_int(L-1))*V(L-1);
        DF(L+2,L+1)=polyval(P1ux_tautheta,aa_int-a_int,x_int(L-1))*V(L-1);
        DF(L+3,L-1)=polyval(P1uy_theta2,aa_int-a_int,x_int(L-1))*V(L-1);
        DF(L+3,L+1)=polyval(P1uy_tautheta,aa_int-a_int,x_int(L-1))*V(L-1);
        for i=3:L-2
            if mod(i,2)==1
                DF(L+1+i,i-2)=-2*aa_int*V(i-2);
                DF(L+1+i,L+1)=-2*x_int(i-2)*V(i-2);
            end
            
        end
        DF(2*L,L-3)=-2*aa_int*V(L-3);
        DF(2*L,L)=-polyval(P1sx_theta2,aa_int-a_int,x_int(L))*V(L);
        DF(2*L,L+1)=-2*aa_int*V(L-3)-polyval(P1sx_tautheta,aa_int-a_int,x_int(L))*V(L);
        DF(2*L+1,L)=-polyval(P1sy_theta2,aa_int-a_int,x_int(L))*V(L);
        DF(2*L+1,L+1)=-polyval(P1sy_tautheta,aa_int-a_int,x_int(L))*V(L);
    end

% e=0.343152170974353 for h=0.001
% e=0.003426910917257 for h=0.0001
% e=3.430417917685833e-05 for h=0.00001

% h=ones(1,37)*0.00001;
% E=F_saddle(x_0+h)-F_saddle(x_0)-DF_saddle(x_0)*h';        
%FF=F_saddle(x_0);
% e=norm(E);
% A1=norm(inv(DF_saddle(x_0)));
% A2=norm(DF_saddle(x_0)\F_saddle(x_0));

v=[0.072802041543708 -0.022651107912389 -0.246598617827939 0.021840612463112 -0.399557716364661 -0.073979585348382 0.818573745001379 -0.119867314909398 0.073817387140899 0.245572123500414 -0.006385376328108 0.022145216142270 0.002190629727387 -0.001915612898432 0.000467540567296 0.000657188918216 -0.130588658178559 -0.000166627203726];
[w,s,t]=Henon_map;
a1=1.3;
a_1=1.1549;%1.2245;%1.3079;%1.2238;%1.226;% 1.3053;%1.385545413332598
W=horzcat(w(1:L-2),s,t,a_1,v);
[x1]=sys_sol(W);
x1_int=intval(x1);
a=x1(L+1);
a_int=intval(a1);
b_int = intval('0.3');
%Parameterization Controls:
M2 = 15;
N2 = 25;

scale_eigs = intval(1);

%Parameter Domains:
tauBar1 = intval('0.1325');
tau = intval('0.1325');   %0.23 works
nu = intval('0.95');
%First Fixed Point:



[P1s_MNx, P1s_MNy, delta1s] = manifoldBranch_1Stable(...
    a_int,  b_int, M2, N2, tauBar1,tau, nu, scale_eigs);

[P1s_x, P1s_y] = convertToPoly_2Dbranch_2Dspace(P1s_MNx, P1s_MNy, M2, N2);

[P1u_MNx, P1u_MNy, delta1u] = manifoldBranch_1Unstable(...
    a_int,  b_int, M2, N2, tauBar1,tau, nu, scale_eigs);

[P1u_x, P1u_y] = convertToPoly_2Dbranch_2Dspace(P1u_MNx, P1u_MNy, M2, N2);




P1ux_theta = pderiv(P1u_x,'x', 1);  %First Derivative of P1 wrt theta
P1uy_theta=pderiv(P1u_y,'x', 1);
P1sx_theta = pderiv(P1s_x,'x', 1);
P1sy_theta=pderiv(P1s_y,'x', 1);

P1ux_theta2 = pderiv(P1u_x,'x', 2);  %Second Derivative of P1 wrt theta
P1uy_theta2=pderiv(P1u_y,'x', 2);
P1sx_theta2 = pderiv(P1s_x,'x', 2);
P1sy_theta2=pderiv(P1s_y,'x', 2);


P1ux_tau = pderiv(P1u_x,'t', 1);  %First Derivative of P1 wrt tau
P1uy_tau=pderiv(P1u_y,'t', 1);
P1sx_tau = pderiv(P1s_x,'t', 1);
P1sy_tau=pderiv(P1s_y,'t', 1);

P1ux_tau2 = pderiv(P1u_x,'t', 2);  %Second Derivative of P1 wrt tau
P1uy_tau2=pderiv(P1u_y,'t', 2);
P1sx_tau2 = pderiv(P1s_x,'t', 2);
P1sy_tau2=pderiv(P1s_y,'t', 2);

P1ux_tautheta=pderiv(P1ux_theta,'t',1);  %Mixed Derivative of P1
P1uy_tautheta=pderiv(P1uy_theta,'t',1);
P1sx_tautheta=pderiv(P1sx_theta,'t',1);
P1sy_tautheta=pderiv(P1sy_theta,'t',1);

P1ux_theta3 = pderiv(P1u_x,'x', 3);  %Third Derivative of P1 wrt theta
P1uy_theta3=pderiv(P1u_y,'x', 3);
P1sx_theta3 = pderiv(P1s_x,'x', 3);
P1sy_theta3=pderiv(P1s_y,'x', 3);

P1ux_tautheta2=pderiv(P1ux_theta2,'t',1);  %Mixed Derivative of P1
P1uy_tautheta2=pderiv(P1uy_theta2,'t',1);
P1sx_tautheta2=pderiv(P1sx_theta2,'t',1);
P1sy_tautheta2=pderiv(P1sy_theta2,'t',1);

P1ux_tau2theta=pderiv(P1ux_tau2,'x',1);  %Mixed Derivative of P1
P1uy_tau2theta=pderiv(P1uy_tau2,'x',1);
P1sx_tau2theta=pderiv(P1sx_tau2,'x',1);
P1sy_tau2theta=pderiv(P1sy_tau2,'x',1);

P1ux_tau3 = pderiv(P1u_x,'t', 3);  %Third Derivative of P1 wrt theta
P1uy_tau3=pderiv(P1u_y,'t', 3);
P1sx_tau3 = pderiv(P1s_x,'t', 3);
P1sy_tau3=pderiv(P1s_y,'t', 3);


%Second Fixed Point:
% 
% [P2s_MNx, P2s_MNy, delta2s] = manifoldBranch_2Stable(...
%     a2,  b2, M2, N2, tauBar1,tau, nu, scale_eigs);
% 
% 
% [P2u_MNx, P2u_MNy, delta2u] = manifoldBranch_2Untable(...
%     a2,  b2, M2, N2, tauBar1,tau, nu, scale_eigs);



FF=F_saddle_intval(x1);

%-------------------------Y-Bound------------------------------------------

F_error=intval(zeros(2*L+1,1));
F_error(1)=delta1u;
F_error(2)=delta1u;
F_error(L-1)=delta1s;
F_error(L)=delta1s;
F_error(L+2)=intval(2*pi*delta1u/(nu*-log((x1_int(L-1)+nu)/(2*nu))));
F_error(L+3)=intval(2*pi*delta1u/(nu*-log((x1_int(L-1)+nu)/(2*nu))));
F_error(2*L)=intval(2*pi*delta1s/(nu*-log((x1_int(L)+nu)/(2*nu))));
F_error(2*L+1)=intval(2*pi*delta1s/(nu*-log((x1_int(L)+nu)/(2*nu))));
    
A=inv(DF_saddle_intval(x1));
Y=abs(DF_saddle_intval(x1)\(F_saddle_intval(x1)+F_error));

%-------------------------Z-Bound----------------R--------------------------
delta=infsup(-1,1);
x1_star=x1_int+delta*10^(-1);

function [A_int]=D2F(x)
        x_int=x;
        v_int=x_int(L+2:2*L+1);
        a1_int=intval(x(L+1));
        d_int=a1_int-a_int;
        A_int=intval(zeros(2*L+1,2*L+1,2*L+1));

for k=1:L-2
    if mod(k,2)==1
       for ii=1:2*L+1
            for jj=1:2*L+1
             if ii==k+2
                if jj==ii-2
                A_int(ii,jj,k)=-2*a1_int;
                elseif jj==L+1
                    A_int(ii,jj,k)=-2*x_int(k);
                end
             elseif ii==L+k+3
                 if jj==L+k+1
                     A_int(ii,jj,k)=-2*a1_int;
                 end
            end
           end 
       end
    end
end
 %------------------------k=L-1------------------------------------
                 for ii=1:2*L+1
                         if ii==1
                           A_int(ii,L-1,L-1)=polyval(P1ux_theta2,d_int,x_int(L-1));
                         elseif ii==2
                           A_int(ii,L-1,L-1)=polyval(P1uy_theta2,d_int,x_int(L-1));
                         elseif ii==L+2
                           A_int(ii,L-1,L-1)=polyval(P1ux_theta3,d_int,x_int(L-1))*v_int(L-1);
                         elseif ii==L+3
                           A_int(ii,L-1,L-1)=polyval(P1uy_theta3,d_int,x_int(L-1))*v_int(L-1);
                         end
                 end
                        for ii=1:2*L+1
                            if ii==1
                                A_int(ii,L+1,L-1)=polyval(P1ux_tautheta,d_int,x_int(L-1));
                            elseif ii==2
                                A_int(ii,L+1,L-1)=polyval(P1uy_tautheta,d_int,x_int(L-1));
                            elseif ii==L+2
                                A_int(ii,L+1,L-1)=polyval(P1ux_tautheta2,d_int,x_int(L-1))*v_int(L-1);
                            elseif ii==L+3
                                A_int(ii,L+1,L-1)=polyval(P1uy_tautheta2,d_int,x_int(L-1))*v_int(L-1);
                            end
                        end
 
                     for ii=1:2*L+1
                         if ii==L+2
                           A_int(ii,2*L,L-1)=polyval(P1ux_theta2,d_int,x_int(L-1));
                         elseif ii==L+3
                           A_int(ii,2*L,L-1)=polyval(P1uy_theta2,d_int,x_int(L-1));
                         end
                     end
                     
%----------------------------k=L-------------------------------------------
            for ii=1:2*L+1
                         if ii==L-1
                           A_int(ii,L,L)=-polyval(P1sx_theta2,d_int,x_int(L));
                         elseif ii==L
                           A_int(ii,L,L)=-polyval(P1sy_theta2,d_int,x_int(L));
                         elseif ii==2*L
                           A_int(ii,L,L)=-polyval(P1sx_theta3,d_int,x_int(L))*v_int(L);
                         elseif ii==2*L+1
                           A_int(ii,L,L)=-polyval(P1sy_theta3,d_int,x_int(L))*v_int(L);
                         end
            end
                        for ii=1:2*L+1
                            if ii==L-1
                                A_int(ii,L+1,L)=-polyval(P1sx_tautheta,d_int,x_int(L));
                            elseif ii==L
                                A_int(ii,L+1,L)=-polyval(P1sy_tautheta,d_int,x_int(L));
                            elseif ii==2*L
                                A_int(ii,L+1,L)=-polyval(P1sx_tautheta2,d_int,x_int(L))*v_int(L);
                            elseif ii==2*L+1
                                A_int(ii,L+1,L)=-polyval(P1sy_tautheta2,d_int,x_int(L))*v_int(L);
                            end
                        end
    
 
                     for ii=1:2*L+1
                         if ii==2*L
                           A_int(ii,2*L+1,L)=-polyval(P1sx_theta2,d_int,x_int(L));
                         elseif ii==2*L+1
                           A_int(ii,2*L+1,L)=-polyval(P1sy_theta2,d_int,x_int(L));
                         end
                     end
   %------------------k=L+1----------------------
        
                for ii=1:2*L+1
                         if ii==1
                           A_int(ii,L-1,L+1)=polyval(P1ux_tautheta,d_int,x_int(L-1));
                         elseif ii==2
                           A_int(ii,L-1,L+1)=polyval(P1uy_tautheta,d_int,x_int(L-1));
                         elseif ii==L+2
                           A_int(ii,L-1,L+1)=polyval(P1ux_tautheta2,d_int,x_int(L-1))*v_int(L-1);
                         elseif ii==L+3
                           A_int(ii,L-1,L+1)=polyval(P1uy_tautheta2,d_int,x_int(L-1))*v_int(L-1);
                         end
                 end
                        for ii=1:2*L+1
                            if ii==1
                                A_int(ii,L+1,L+1)=polyval(P1ux_tau2,d_int,x_int(L-1));
                            elseif ii==2
                                A_int(ii,L+1,L+1)=polyval(P1uy_tau2,d_int,x_int(L-1));
                            elseif ii==L+2
                                A_int(ii,L+1,L+1)=polyval(P1ux_tau2theta,d_int,x_int(L-1))*v_int(L-1);
                            elseif ii==L+3
                                A_int(ii,L+1,L+1)=polyval(P1uy_tau2theta,d_int,x_int(L-1))*v_int(L-1);
                            end
                        end
 
                     for ii=1:2*L+1
                         if ii==L+2
                           A_int(ii,2*L,L+1)=polyval(P1ux_tautheta,d_int,x_int(L-1));
                         elseif ii==L+3
                           A_int(ii,2*L,L+1)=polyval(P1uy_tautheta,d_int,x_int(L-1));
                         end
                     end
                     
            for ii=1:2*L+1
                         if ii==L-1
                           A_int(ii,L,L+1)=-polyval(P1sx_tautheta,d_int,x_int(L));
                         elseif ii==L
                           A_int(ii,L,L+1)=-polyval(P1sy_tautheta,d_int,x_int(L));
                         elseif ii==2*L
                           A_int(ii,L,L+1)=-polyval(P1sx_tautheta2,d_int,x_int(L))*v_int(L);
                         elseif ii==2*L+1
                           A_int(ii,L,L+1)=-polyval(P1sy_tautheta2,d_int,x_int(L))*v_int(L);
                         end
            end
                        for ii=1:2*L+1
                            if ii==L-1
                                A_int(ii,L+1,L+1)=-polyval(P1sx_tau2,d_int,x_int(L));
                            elseif ii==L
                                A_int(ii,L+1,L+1)=-polyval(P1sy_tau2,d_int,x_int(L));
                            elseif ii==2*L
                                A_int(ii,L+1,L+1)=-polyval(P1sx_tau2theta,d_int,x_int(L))*v_int(L);
                            elseif ii==2*L+1
                                A_int(ii,L+1,L+1)=-polyval(P1sy_tau2theta,d_int,x_int(L))*v_int(L);
                            end
                        end
    
 
                     for ii=1:2*L+1
                         if ii==2*L
                           A_int(ii,2*L+1,L+1)=-polyval(P1sx_tautheta,d_int,x_int(L));
                         elseif ii==2*L+1
                           A_int(ii,2*L+1,L+1)=-polyval(P1sy_tautheta,d_int,x_int(L));
                         end
                     end
        for ii=3:L
             if mod(ii,2)==1
                A_int(ii,ii-2,L+1)=-2*x_int(ii-2);
             end
        end
        
        for ii=L+4:2*L
            if mod(ii,2)==0
                A_int(ii,ii-L-3,L+1)=-2*v_int(ii-L-3);
                A_int(ii,ii-2,L+1)=-2*x_int(ii-L-3);
            end
        end
 %--------------------k=L+2:2L+1-------------------------------------       
    for k=L+2:2*L+1
        A_int(L+1,k,k)=2;
        if mod(k,2)==0 && k<2*L
            A_int(k+2,k-L-1,k)=-2*a1_int;
        end
        if k==2*L
            A_int(L+2,L-1,k)=polyval(P1ux_theta2,d_int,x_int(L-1));
            A_int(L+3,L-1,k)=polyval(P1uy_theta2,d_int,x_int(L-1));
            A_int(L+2,L+1,k)=polyval(P1ux_tautheta,d_int,x_int(L-1));
            A_int(L+3,L+1,k)=polyval(P1uy_tautheta,d_int,x_int(L-1));
        
        elseif k==2*L+1
            A_int(2*L,L,k)=-polyval(P1sx_theta2,d_int,x_int(L));
            A_int(2*L+1,L,k)=-polyval(P1sy_theta2,d_int,x_int(L));
            A_int(2*L,L+1,k)=-polyval(P1sx_tautheta,d_int,x_int(L));
            A_int(2*L+1,L+1,k)=-polyval(P1sy_tautheta,d_int,x_int(L));
        end
    end
            
       
    end
Z=D2F(x1_star);
ZQ_sum=intval(zeros(2*L+1,2*L+1));
for i3=1:2*L+1
    ZQ_sum=ZQ_sum+mag(Z(:,:,i3));
end

%---------Linear term in radii polynomials-----------------------
DP_x=intval(2*pi*delta1u/(nu*-log((x1_int(5)+nu)/(2*nu))));
DQ_x=intval(2*pi*delta1s/(nu*-log((x1_int(6)+nu)/(2*nu))));
DP_a=2*pi*delta1u/(tau*-log((x1_int(L+1)+tau)/(2*tau)));
DQ_a=2*pi*delta1s/(tau*-log((x1_int(L+1)+tau)/(2*tau)));
ZL_error=intval(zeros(2*L+1,2*L+1));
ZL_error(1,L-1)=DP_x;
ZL_error(2,L-1)=DP_x;
ZL_error(1,L+1)=DP_a;
ZL_error(2,L+1)=DP_a;
ZL_error(L-1,L)=DQ_x;
ZL_error(L,L)=DQ_x;
ZL_error(L-1,L+1)=DQ_a;
ZL_error(L,L+1)=DQ_a;
ZL_error(L+2,L-1)=DP_x^2;
ZL_error(L+2,L+1)=DP_x*DP_a;
ZL_error(L+2,2*L)=DP_x;
ZL_error(L+3,L-1)=DP_x^2;
ZL_error(L+3,L+1)=DP_x*DP_a;
ZL_error(L+3,2*L)=DP_x;
ZL_error(2*L,L)=DQ_x^2;
ZL_error(2*L,L+1)=DQ_x*DQ_a;
ZL_error(2*L,2*L+1)=DQ_x;
ZL_error(2*L+1,L)=DQ_x^2;
ZL_error(2*L+1,L+1)=DQ_x*DQ_a;
ZL_error(2*L+1,2*L+1)=DQ_x;

ZL=abs(intval(eye(2*L+1,2*L+1))-A*(DF_saddle_intval(x1_int)+ZL_error))*ones(2*L+1,1);

%--------Quadratic term in radii polynomials-------------------
ZQ_error=intval(zeros(2*L+1,2*L+1,5));
ZQ_error(1,L-1,1)=DP_x^2;
ZQ_error(1,L+1,1)=DP_x*DP_a;
ZQ_error(2,L-1,1)=DP_x^2;
ZQ_error(2,L+1,1)=DP_x*DP_a;
ZQ_error(L+2,L-1,1)=DP_x^3;
ZQ_error(L+2,L+1,1)=DP_x^2*DP_a;
ZQ_error(L+3,L-1,1)=DP_x^3;
ZQ_error(L+3,L+1,1)=DP_x^2*DP_a;
ZQ_error(L+2,2*L,1)=DP_x^2;
ZQ_error(L+3,2*L,1)=DP_x^2;


ZQ_error(L-1,L,2)=DQ_x^2;
ZQ_error(L-1,L+1,2)=DQ_x*DQ_a;
ZQ_error(L,L,2)=DQ_x^2;
ZQ_error(L,L+1,2)=DQ_x*DQ_a;
ZQ_error(2*L,L,2)=DQ_x^3;
ZQ_error(2*L,L+1,2)=DQ_x^2*DQ_a;
ZQ_error(2*L+1,L,2)=DQ_x^3;
ZQ_error(2*L+1,L+1,2)=DQ_x^2*DQ_a;
ZQ_error(2*L,2*L+1,2)=DQ_x^2;
ZQ_error(2*L+1,2*L+1,2)=DQ_x^2;


ZQ_error(1,L-1,3)=DP_x*DP_a;
ZQ_error(1,L+1,3)=DP_a^2;
ZQ_error(2,L-1,3)=DP_x*DP_a;
ZQ_error(2,L+1,3)=DP_a^2;
ZQ_error(L-1,L,3)=DQ_x*DQ_a;
ZQ_error(L-1,L+1,3)=DQ_a^2;
ZQ_error(L,L,3)=DQ_x*DQ_a;
ZQ_error(L,L+1,3)=DQ_a^2;
ZQ_error(L+2,L-1,3)=DP_x^2*DP_a;
ZQ_error(L+2,L+1,3)=DP_x*DP_a^2;
ZQ_error(L+3,L-1,3)=DP_x^2*DP_a;
ZQ_error(L+3,L+1,3)=DP_a^2*DP_x;
ZQ_error(L+2,2*L,3)=DP_x*DP_a;
ZQ_error(L+3,2*L,3)=DP_x*DP_a;
ZQ_error(2*L,L,3)=DQ_x^2*DQ_a;
ZQ_error(2*L,L+1,3)=DQ_x*DQ_a^2;
ZQ_error(2*L+1,L,3)=DQ_x^2*DQ_a;
ZQ_error(2*L+1,L+1,3)=DQ_a^2*DQ_x;
ZQ_error(2*L,2*L+1,3)=DQ_x*DQ_a;
ZQ_error(2*L+1,2*L+1,3)=DQ_x*DQ_a;


ZQ_error(L+1,L-1,4)=DP_x^2;
ZQ_error(L+2,L-1,4)=DP_x^2;
ZQ_error(L+1,L+1,4)=DP_x*DP_a;
ZQ_error(L+2,L+1,4)=DP_x*DP_a;


ZQ_error(2*L,L,5)=DQ_x^2;
ZQ_error(2*L,L+1,5)=DQ_x*DQ_a;
ZQ_error(2*L+1,L,5)=DQ_x^2;
ZQ_error(2*L+1,L+1,5)=DQ_x*DQ_a;

ZQ_error_sum=zeros(2*L+1,2*L+1);
for i4=1:5
    ZQ_error_sum=ZQ_error_sum+ZQ_error(:,:,i4);
end
ZQ=abs(A)*((ZQ_sum+ZQ_error_sum)*ones(2*L+1,1));


%--------Calculating roots-----------------------------------------
r_1=ZL-intval(ones(2*L+1,1));
r_2=ZQ;
Ybd=Y;
R2=(-r_1(:)+sqrt(r_1(:).^2-4*r_2(:).*Ybd(:)))./(2.*r_2(:));
R1=(-r_1(:)-sqrt(r_1(:).^2-4*r_2(:).*Ybd(:)))./(2.*r_2(:));






%----------------Eigenvalue/Eigenvector Validation--------------------------------
M=jacob2_intval(x1_int(1:L),x1_int(L+1),x1_int(L+1)-a_int);
[V,E]=eig(mid(M));
[~,n]=min(abs(diag(E)));
r1=intval(zeros(L,L));
r2=intval(zeros(L,L));
R_1=intval(zeros(L,L));
R_2=intval(zeros(L,L));
Ybd_e=intval(zeros(L,L));
check=intval(zeros(L,L));
counter=1;
% function [F]=F_eig_intval(v,m,v_kk,kk)
%         F=intval(zeros(1,L));
%         v=intval(v);
%         vv=horzcat(v(1:kk-1)',intval(v_kk),v(kk+1:L)');
%         F=M*vv'-m*vv';
% end
zero_eig_index=n;
for i=1:18
    
v=V(:,i);
[~,kk]=max(abs(v));
v=intval(v);
mu=intval(E(i,i));
W=ones(L,L)*10;
F_eig_intval=M*v-mu*v;
%DF_eig_intval=intval(zeros(L,L)); 
D=M-mu*intval(eye(L,L)); 
D_k=D;
D_k(:,kk)=[];
DF_eig_intval=horzcat(-v,D_k);
A2=inv(DF_eig_intval);
A3=inv(DF_eig_intval)*F_eig_intval;
%------------------Y-Bound-----------------------------------
Ybd_e(:,counter)=abs(A2*F_eig_intval);

   
%------------------linear and quadratic coefficient-----------------------------------
B=intval(eye(L));
Z_Q=2*abs(A2)*(intval(ones(L,1))-B(:,kk));
Z_L=abs(intval(eye(L))-A2*DF_eig_intval)*intval(ones(L,1));
check(:,counter)=Z_L;
r1(:,counter)=Z_L-intval(ones(L,1));
r2(:,counter)=Z_Q;
R_2(:,counter)=(-r1(:,counter)+sqrt(r1(:,counter).^2-4*r2(:,counter).*Ybd_e(:,counter)))./(2*r2(:,counter));
R_1(:,counter)=(-r1(:,counter)-sqrt(r1(:,counter).^2-4*r2(:,counter).*Ybd_e(:,counter)))./(2*r2(:,counter));
counter=counter+1;
end
%------------------- Compute <w>=Ker(D^T)--------------------------------
    function [K]=Kernel_func(x)
        M_T=mid(M.');
        K=M_T*x.'; 
    end
        
function x = Newton_Henon_Ker(x0)%x = Newton_Henon(x0,aa,v)
N = 2000; % define max. number of iterations 
epsilon = 1e-13; % define tolerance 
maxval = 20000.0; % define value for divergence 
xx = mid(x0); % load initial guess            
             
while (N>0) 
 %JJ = feval(jacobnxn,xx);
 %JJ=mid(jacob2_intval(intval(xx),aa,aa-a_int));
 JJ=mid(M.');
if abs(det(JJ))<epsilon 
 error('newtonm - Jacobian is singular - try new x0'); 
 abort; 
end
% xn = xx - inv(JJ)*feval(fn,xx);
 %xn = xx - (inv(JJ)*mid(gn_intval(intval(xx),aa,aa-a_int)))';
 xn = xx - (JJ\Kernel_func(xx))';
%if abs(feval(fn,xn))<epsilon 
 %if norm(mid(gn_intval(intval(xn),aa,aa-a_int)))<epsilon 
 if norm(Kernel_func(xn))<epsilon 
 x=xn; 
 iter = 2000-N;
 disp(['iterations = ',num2str(iter)]); 
 return; 
 end 
%if abs(feval(fn,xx))>maxval 
 if norm(Kernel_func(xx))>maxval 
 iter = 2000-N; 
 disp(['iterations = ',num2str(iter)]); 
 error('Solution diverges'); 
 abort; 
 end 
 N = N - 1; 
 xx = xn; 
end 
error('No convergence after 2000 iterations.'); 
abort; 
end 

[V_1,D_1,W_1]=eig(mid(M));
%x_eig= Newton_Henon_Ker(W_1(:,1).'); 
x_eig=W_1(:,n).';
%(M.')*x_eig.';
v_1=V(:,n);
[~,kk_1]=max(abs(v_1));
D_k1=mid(M);
D_k1(:,kk_1)=[];
    function [G]=G_w(w)
        G(1)=norm(w)^2-1;
        G(2:L)=(D_k1.')*w.';
    end
GG=G_w(x_eig);
    function [DG]=DG_w(w)
        DG=vertcat(2*w,D_k1.');
    end
function x = Newton_Henon_ker2(x0)%x = Newton_Henon(x0,aa,v)
N = 2000; % define max. number of iterations 
epsilon = 1e-13; % define tolerance 
maxval = 20000.0; % define value for divergence 
xx = mid(x0); % load initial guess            
             
while (N>0) 
 %JJ = feval(jacobnxn,xx);
 %JJ=mid(jacob2_intval(intval(xx),aa,aa-a_int));
 JJ=mid(DG_w(xx));
if abs(det(JJ))<epsilon 
 error('newtonm - Jacobian is singular - try new x0'); 
 abort; 
end
% xn = xx - inv(JJ)*feval(fn,xx);
 %xn = xx - (inv(JJ)*mid(gn_intval(intval(xx),aa,aa-a_int)))';
 xn = xx - (JJ\G_w(xx).')';
%if abs(feval(fn,xn))<epsilon 
 %if norm(mid(gn_intval(intval(xn),aa,aa-a_int)))<epsilon 
 if norm(G_w(xn))<epsilon 
 x=xn; 
 iter = 2000-N;
 disp(['iterations = ',num2str(iter)]); 
 return; 
 end
%if abs(feval(fn,xx))>maxval 
 if norm(G_w(xx))>maxval 
 iter = 2000-N; 
 disp(['iterations = ',num2str(iter)]); 
 error('Solution diverges'); 
 abort;
 end 
 N = N - 1; 
 xx = xn; 
end 
error('No convergence after 2000 iterations.'); 
abort; 
end 
x_w = Newton_Henon_ker2((1/norm(x_eig))*x_eig);

%-----------------Y_bd--------------------------------------
A_w=inv(intval(DG_w(x_w))); 
Ybd_w=abs(A_w)*intval(G_w(x_w).');

%---------------Z_bd----------------------------------------
r1_w=intval(zeros(L,1));
r2_w=intval(zeros(L,1));
R1_w=intval(zeros(L,1));
R2_w=intval(zeros(L,1));
Z1_w=abs(intval(eye(L))-A_w*intval(DG_w(x_w)))*intval(ones(L,1));
Z2_w=2*abs(A_w)*ones(L,1);
r1_w(:)=Z1_w-intval(ones(L,1));
r2_w(:)=Z2_w;
R2_w(:)=(-r1_w(:)+sqrt(r1_w(:).^2-4*r2_w(:).*Ybd_w(:)))./(2*r2_w(:));
R1_w(:)=(-r1_w(:)-sqrt(r1_w(:).^2-4*r2_w(:).*Ybd_w(:)))./(2*r2_w(:));


end