function varargout = henon_invariantBranch_intval(...
    x_M, y_M, PN1, PN2, PN1_rho, PN2_rho, ...
    lambda_series, Lambda_series, ...
    xi_1_series, xi_2_series, M, N, a, b);




PMN1 = intval(zeros(M+1, N+1));
PMN2 = intval(zeros(M+1, N+1));

PMN1(1, :) = PN1;
PMN2(1, :) = PN2;

PMN1(2, :) = PN1_rho;
PMN2(2, :) = PN2_rho;


PMN1(3:M+1, 1) = x_M(3:M+1);
PMN2(3:M+1, 1) = y_M(3:M+1);
PMN1(3:M+1, 2) = xi_1_series(3:M+1)';
PMN2(3:M+1, 2) = xi_2_series(3:M+1)';

Dfp0 = [-2*a*PN1(1), 1;
                  b, 0];
    
              
Id = intval(eye(2));

lambda = lambda_series(1);

for n = 2:N
	 n
	 N
    for m = 2:M
        A = Dfp0 - lambda^n*Id;
         
        thisTerm1 = intval(0);
        thisTerm2 = intval(0);
 
        for l = 0:(m-1)
            thisTerm1 = thisTerm1 + ...
                Lambda_series(m-l+1, n+1)*PMN1(l+1, n+1);
            thisTerm2 = thisTerm2 + ...
                Lambda_series(m-l+1, n+1)*PMN2(l+1, n+1);
        end
        
        smn_term = ...
            convolution_henon_smn_intval(...
                m,n,PMN1,PMN2, a, b, M, N);
        
        smn1 = thisTerm1 + smn_term;
        smn2 = -PMN1(m, n+1) + thisTerm2;
        
        b = [smn1;
             smn2];
         
        thisCoeff = A\b;
        
        PMN1(m+1, n+1) = thisCoeff(1);
        PMN2(m+1, n+1) = thisCoeff(2);
    end
end
                          
                                  
varargout(1,1)={PMN1};
varargout(2,1)={PMN2};
