function varargout=henon_eigValVectValidate_intval_hack(...
    xM, yM, lambda, xi, M, tau, scale_eig, delta, a, b);




%========================================================================
%Eigenvalue Expansion:
%========================================================================

[lambda_series] = henon_eigVal_expansion_intval(xM, lambda, a, b, M);


%==========================================================================
%Eigenvalue Residual Error:
%==========================================================================

% 
 lambda_squared = ...
     convolveSeries_1D_general_intval(lambda_series, lambda_series);

lambda_xM =  ...
    convolveSeries_1D_general_intval(lambda_series, xM);
 
 

Error = lambda_squared + 2*a*lambda_xM;
 
Error(1) = Error(1) - b;
Error(2) = Error(2) - 1;

sigma_error = intval(0);
for m = 0:(2*M)
    sigma_error = sigma_error + abs(Error(m+1))*abs(tau)^m; 
end
% 
lambda_aPosError = sup(sigma_error)


%==========================================================================
%Validate Eigenvalue:
%==========================================================================

% 
%Sigma Norm of lambda_M:
lambda_M_norm = 0;
for m = 0:M
     lambda_M_norm = lambda_M_norm + abs(lambda_series(m+1))*tau^m;
end
% 
lambda_M_norm
 
 
%Bound on second derivatives of fixed point operator:
Kappa_lambda = 2
% 
%TauBar Check:
B0_inv = 1/(2*abs(lambda + a*xM(1)))

BM = intval(zeros(M+1, 1));
BM(1) = 2*abs(lambda + a*xM(1));
for m = 1:M
   BM(m+1) = 2*(lambda_series(m+1) + a*xM(m+1)); 
end

delta_B = 2*abs(a)*delta

checkSum = 0;
for m = 1:M
    checkSum = checkSum + abs(BM(m+1))*tau^(m-1); 
end

checkSum = B0_inv*(tau*checkSum + delta_B)

if (sup(checkSum) >= 1)
    crashNow = B_not_invertible_on_this_domain
end



CM = matrixSeries_formalInverse_intval(BM', M);
delta_C = matrixSeries_validateInverse_intval(BM', CM, delta_B, tau, M);


CM_bound = horner(tau, abs(CM), M);

epsilon = lambda_aPosError + 2*abs(a)*lambda_M_norm*delta

delta_lambda = 2*(CM_bound + delta_C)*epsilon

NK_test = 4*epsilon*Kappa_lambda*(CM_bound + delta_C)^2

if sup(NK_test) >= 1
    crashNow = lambda_newtonFailed
end

sup(delta_lambda)


%==========================================================================
%Expansion of Eigenvector:
%==========================================================================


[xi_n] = henon_eigVect_expansion_intval(...
    xM, lambda_series, xi, a, b, M);


xi_1_series = xi_n(1,:);
xi_2_series = xi_n(2,:);



% 
% 
% %==========================================================================
% %Eigenvectior Residual Error:
%==========================================================================

big_xi1 = intval(zeros(1, 2*M+1));
big_xi2 = intval(zeros(1, 2*M+1));
big_omega_xi1 = intval(zeros(1, 2*M+1));
 
big_xi1(1:M+1) = xi_1_series;
big_xi2(1:M+1) = xi_2_series;
big_omega_xi1(2:M+2) = xi_1_series;
 
xi1_squared = convolveSeries_1D_general_intval(xi_1_series, xi_1_series);
xi2_squared = convolveSeries_1D_general_intval(xi_2_series, xi_2_series);
xi2_times_lambda = ...
     convolveSeries_1D_general_intval(xi_2_series, lambda_series);

 
Error_1 = b*big_xi1+big_omega_xi1 - xi2_times_lambda;
Error_2 = xi1_squared + xi2_squared; 
Error_2(1) = Error_2(1) - ((scale_eig)^2)*intval(1);
 
sigmaError1 = intval(0);
sigmaError2 = intval(0);  
for m = 0:2*M
     sigmaError1 = sigmaError1 + abs(Error_1(m+1))*abs(tau)^m;
     sigmaError2 = sigmaError2 + abs(Error_2(m+1))*abs(tau)^m; 
end
  
sigmaError_eigVect = max([sup(sigmaError1), sup(sigmaError2)])
 
 
xi2_bound = horner(tau, abs(xi_2_series), M)

xi_aPosteriori = sigmaError_eigVect + xi2_bound*delta_lambda


% 
% %==========================================================================
% %A-posteriori validation Eigenvect:
% %==========================================================================
% 
% 

if (inf(abs(lambda(1))) > 1)

pM1 = convertToPoly_1D1D(xM, M);
pM2 = convertToPoly_1D1D(yM, M);
lambda_poly = convertToPoly_1D1D(lambda_series, M);

c1 = 1/(2*(polyval(abs(pM1), tau) + ...
           delta)*(abs(1 - (b+tau)^2)))

C_bound = c1*(2*polyval(abs(pM1), tau) + 2*polyval(abs(pM2), tau) + ...
    4*delta + polyval(abs(lambda_poly), tau) + delta_lambda + ...
    abs(b) + tau)
elseif (inf(lambda(1)) > 0)   
pM1 = convertToPoly_1D1D(xM, M);
pM2 = convertToPoly_1D1D(yM, M);
lambda_poly = convertToPoly_1D1D(lambda_series, M);
c1 = 1/(2*(polyval(abs(pM1), tau) + ...
           delta)*(abs(polyval(abs(lambda_poly), tau) + ...
    delta_lambda + (b+tau)^2)))

C_bound = c1*(2*polyval(abs(pM1), tau) + 2*polyval(abs(pM2), tau) + ...
    4*delta + polyval(abs(lambda_poly), tau) + delta_lambda + ...
    abs(b) + tau) 
elseif (sup(abs(lambda(1))) < 1) & (sup(lambda(1)) <  0)
pM1 = convertToPoly_1D1D(xi_1_series, M);
pM2 = convertToPoly_1D1D(xi_2_series, M);
lambda_poly = convertToPoly_1D1D(lambda_series, M);
xi_1_poly = convertToPoly_1D1D(xi_1_series, M);
other_poly = convertToPoly_1D1D([b, 1], 1);

dM = 2*pM2*other_poly+2*pM1*lambda_poly
d_0 = dM(0)
test_poly = dM - d_0

if inf(abs(d_0) - polyval(abs(test_poly), tau) - ...
           2*polyval(abs(xi_1_poly), tau)*delta_lambda) < 0
   crashNow = detCondFailed    
end


c2 = abs(d_0) - polyval(abs(test_poly), tau) - ...
           2*polyval(abs(xi_1_poly), tau)*delta_lambda



c1 = 1/(2*(polyval(abs(pM1), tau) + ...
           delta)*c2)

C_bound = c1*(2*polyval(abs(pM1), tau) + 2*polyval(abs(pM2), tau) + ...
    4*delta + polyval(abs(lambda_poly), tau) + delta_lambda + ...
    abs(b) + tau)  
else
    
    
BM = intval(zeros(2, 2, M+1));

BM(:, :, 1) = [               b,  -lambda_series(1);
         2*xi_1_series(1),   2*xi_2_series(1)];


BM(:, :, 2) = [               1,  -lambda_series(2);
         2*xi_1_series(2),   2*xi_2_series(2)];     
     
     
for m = 2:M
   BM(:, :, m+1) = [                 0,  -lambda_series(m+1);
              2*xi_1_series(m+1),   2*xi_2_series(m+1)];
end
     

delta_B = delta_lambda

B_check = 0
for m = 1:M
   B_check = B_check + norm(BM(:, :, m+1), inf)*tau^(m-1); 
end
     

B0_inv = inv(BM(1))
B_check = norm(B0_inv, inf)*(tau*B_check + delta_B)

if sup(B_check) >= 1
    lambda(1)
   crashNow = eigenVector_invDiff_failed 
end


CM = matrixSeries_formalInverse_intval(BM, M);
delta_C = matrixSeries_validateInverse_intval(BM, CM, delta_B, tau, M)


C_bound =  matrixSeries_sigmaNorm_intval(CM, tau)
C_bound = C_bound + delta_C
end




epsilon_NK_xi = xi_aPosteriori*C_bound

Kappa_xi = 4
delta_xi = 2*epsilon_NK_xi

xi_newton_check = 4*Kappa_xi*epsilon_NK_xi*C_bound

if sup(xi_newton_check) >= 1
    crashNow = xi_newton_failed_crash
end



varargout(1,1)={lambda_series};
varargout(2,1)={xi_1_series};
varargout(3,1)={xi_2_series};
varargout(4,1)={delta_lambda};
varargout(5,1)={delta_xi};






